#include <stdio.h>
#include <limits.h>
#include <mqueue.h>
#include <signal.h>
#include <stdlib.h>
#include <errno.h>



static mqd_t fbq;

void
receive_mq(int signo,siginfo_t *siginfo, void *val)
{
	unsigned int recv,msg_prio;
	struct sigevent notification;

        printf("\tsi_signo\t%d\n\tsi_code\t\t%d\n\tsi_pid\t\t%d\n\tsi_status\t%d\n\tsi_uid\t\t%d\n\tsi_value\t%d\n\tsi_addr\t\t%d\n\tsi_fd\t\t%d\n\tsi_band\t\t%d\n\n",
        siginfo->si_signo,
        siginfo->si_code,
        siginfo->si_pid,
        siginfo->si_status,
        siginfo->si_uid,
        siginfo->si_value,
        siginfo->si_addr,
        siginfo->si_fd,
        siginfo->si_band);
        fflush(stdout);

        notification.sigev_notify = SIGEV_SIGNAL;
        notification.sigev_signo = SIGRTMIN;
	mq_notify(fbq,&notification);

		mq_receive(fbq,(char*)&recv,sizeof(int),&msg_prio);
		printf("data %d priority %d\n",recv,msg_prio);fflush(stdout);
}

main()
{
	struct mq_attr comattr;
	unsigned int i,send,recv,msg_prio;
	struct sigaction newact;
	struct sigevent notification;
	int signum;
 	static sigset_t set,oset,eiset;


        /* メッセージキュー fbq */
        comattr.mq_flags = O_NONBLOCK;
        comattr.mq_maxmsg = 100;
        comattr.mq_msgsize = sizeof(int);
        comattr.mq_curmsgs = 0;


printf("Message Queue Polling Test\n");
        if ((fbq = mq_open("/fbq",O_RDWR|O_CREAT,0666, &comattr))==(mqd_t)(-1))
        {
		fprintf(stderr,"%s\n",strerror(errno));
                exit(1);
        }

	printf("send message queue    :");
	for (i = 0; i<10;i++)
	{
		send = i;
		if(mq_send(fbq,(char*)&send,sizeof(int),i)<0)
		{
			 fprintf(stderr,"%s\n",strerror(errno));
		}
		printf("%d ",i);fflush(stdout);
	}
	printf("\n");

	printf("receive message queue :");
	for (i = 0; i<10;i++)
	{
		mq_receive(fbq,(char*)&recv,sizeof(int),&msg_prio);
		printf("%x:%x ",msg_prio,recv);fflush(stdout);
	}
	printf("\n");


printf("Message Queue Interrupt Test\n");
        signum = SIGRTMIN;
        sigaddset(&newact.sa_mask,signum);
        newact.sa_sigaction = receive_mq;
        newact.sa_flags = SA_SIGINFO|SA_RESTART;
        sigaction(signum, &newact, 0);

        notification.sigev_notify = SIGEV_SIGNAL;
        notification.sigev_signo = signum;
	mq_notify(fbq,&notification);

printf("send 10\n");
	send = 10;
	mq_send(fbq,(char*)&send,sizeof(int),1);
	sleep(1);
printf("send 9\n");
	send = 9;
	mq_send(fbq,(char*)&send,sizeof(int),1);
	sleep(1);
	mq_close(fbq);
        mq_unlink("/fbq");

}
